//Just Cogs
//Team CAPS LOCKS
//Wyatt Gray: wyattgray1
//Jeffrey Thomas: jthomas

// game.js for Perlenspiel 2
// This is a template for creating new Perlenspiel games
// All of the functions below MUST exist, or the engine will stop and complain!

// The following comment line is for JSLint. Don't remove it!

/*global PS */


var COGS = {};

//The list of all the cogs in the level
COGS.cog_list = [];

//The grid dimensions
COGS.gridX = 32;
COGS.gridY = 31;

//The BeadData of the bead the mouse is currently hovering over
COGS.mouseData = [];

//The cooldown for scroll wheel input
COGS.scrollcd = 2;
COGS.scroll_counter = 0;

//The current level
COGS.currentLevel = 0;

//Whether or not the game is on the title screen
COGS.title = true;

COGS.block_list = [];		//The blocks currently in the game
COGS.block_sources = [];	//The potential spawn points of a block

//Sounds that play when a block is caught correctly
COGS.block_sounds = ["xylo_d6", "xylo_eb6", "xylo_e6", "xylo_f6", "xylo_gb6", "xylo_g6", "xylo_ab6", "xylo_a6"];

COGS.block_source_counter = [];
COGS.source_cd = 60;

COGS.removed_blocks = [];				//Temporary array for removing blocks
COGS.block_cd = 3;						//The cooldown for block movement
COGS.block_counter = COGS.block_cd;		//The counter for block movement
COGS.block_spawn_rate = 60;				//The percent chance a block will spawn
COGS.num_caught = 0;					//The number of blocks caught this level
COGS.level_end = COGS.gridY*2;			//The number of blocks required to end a level

COGS.block_spawn_counter = 0;			//The counter for block spawning
COGS.block_spawn_cd = 12;				//The cooldown for block spawning
COGS.max_blocks = 2;					//The maximum number of blocks that be on-screen this level
COGS.max_blocks_level = [2, 5, 8, 100, 100];	//The maximum number of blocks that be on-screen all levels

//The colors
COGS.COG_COLOR = PS.COLOR_GRAY_DARK;
COGS.GEAR_COLOR = PS.COLOR_GRAY;
COGS.bg_color = PS.COLOR_GRAY_LIGHT;
COGS.block_colors = [0xBB0000, 0x00AAFF, 0x00FF00, 0xFFFF00];
COGS.progress_full = PS.COLOR_BLUE;
COGS.progress_empty = PS.COLOR_CYAN;
COGS.progress_half = 0x00AAFF;
COGS.BG_colors = [];
COGS.tile_colors = [0xBBCCFF, 0xEEEEFF, 0xDDDDFF, 0xFFDDFF];


COGS.AI = false;				//The state of the AI (on/off)
COGS.closest_block = [];		//The [index, distance] of the block closest to each cog
COGS.ai_cd = 1;					//The cooldown of the AI for cog-turning
COGS.ai_counter = COGS.ai_cd;	//The counter for the AI for cog-turning

COGS.flash_cd = 20;
COGS.flash_counter = COGS.flash_cd;


//COGS.tile_colors = [0xFFEECC, 0xEEFFBB, 0xBBFFEE, 0xCCFFCC];
//COGS.tile_colors = [0xFFEECC, 0xEEFFBB, 0xEEDDCC, 0xEEEECC];

//Creates the random colors for the background
COGS.CreateBG = function(){
	for(var i = 0; i < COGS.gridX; i += 1){
		COGS.BG_colors[i] = [];
		for(var j = 0; j < COGS.gridY; j += 1){
			COGS.BG_colors[i][j] = COGS.tile_colors[PS.Random(4) - 1];
		}
	}
}

//Draws the background
COGS.DrawBG = function(){
	for(var i = 0; i < COGS.gridX; i += 1){
		for(var j = 0; j < COGS.gridY; j += 1){
			PS.BeadColor(i, j, COGS.BG_colors[i][j]);
		}
	}
}

//Initializes all the variables for the start of the game
//More variables are set to their default values than InitVariables
COGS.FullInit = function(){
	COGS.cog_list = [];
	
	COGS.mouseData = [];
	COGS.scrollcd = 2;
	COGS.scroll_counter = 0;
	
	COGS.currentLevel = 0;
	COGS.title = true;
	
	COGS.block_list = [];
	COGS.block_sources = [];
	
	COGS.block_source_counter = [];
	
	COGS.removed_blocks = [];
	COGS.block_cd = 3;
	COGS.block_counter = COGS.block_cd;
	COGS.block_spawn_rate = 60;
	COGS.num_caught = 0;
	COGS.level_end = COGS.gridY*2;
	
	COGS.block_spawn_counter = 0;
	COGS.block_spawn_cd = 12;
	COGS.max_blocks = 2;
	
	COGS.AI = false;
	COGS.closest_block = [];
	COGS.ai_cd = 1;
	COGS.ai_counter = COGS.ai_cd;
	
	COGS.CreateBG();
}

//Function to draw the title screen
COGS.DrawTitleScreen = function(){
	//PS.BeadColor(x, y, COLOR)
	//To set the background color do: PS.BeadColor(PS.ALL, PS.ALL, COLOR)
	var x, y;
	
	//To color a row of three beads across red at y = 10, x starting at 3
	//y = 29;
	//for(x = 3; x <= 3 + 3; x += 1){
	//	PS.BeadColor(x, y, PS.COLOR_RED);}
	
	PS.BeadColor(PS.ALL, PS.ALL, 0xAAAAAA);
	
	//Draws the mouse
	
	//3 9 to 12 23
	
	for(x = 3; x <= 12; x +=1)
	for(y = 9; y <= 23; y +=1)
	PS.BeadColor(x, y, PS.COLOR_WHITE);
	y = 8;
	for(x = 5; x <= 10; x +=1)
	PS.BeadColor(x, y, PS.COLOR_WHITE);
	y = 24;
	for(x = 5; x <= 10; x +=1)
	PS.BeadColor(x, y, PS.COLOR_WHITE);
	
	PS.BeadColor(8, 0, PS.COLOR_BLACK);
	PS.BeadColor(8, 1, PS.COLOR_BLACK);
	PS.BeadColor(9, 2, PS.COLOR_BLACK);
	PS.BeadColor(9, 3, PS.COLOR_BLACK);
	PS.BeadColor(8, 4, PS.COLOR_BLACK);
	PS.BeadColor(7, 5, PS.COLOR_BLACK);
	PS.BeadColor(7, 6, PS.COLOR_BLACK);
	PS.BeadColor(8, 6, PS.COLOR_BLACK);
	y = 7;
	for(x = 5; x <= 10; x +=1)
	PS.BeadColor(x, y, PS.COLOR_BLACK);
	PS.BeadColor(4, 8, PS.COLOR_BLACK);
	PS.BeadColor(11, 8, PS.COLOR_BLACK);
	PS.BeadColor(3, 9, PS.COLOR_BLACK);
	PS.BeadColor(12, 9, PS.COLOR_BLACK);
	PS.BeadColor(7, 8, PS.COLOR_BLACK);
	PS.BeadColor(8, 8, PS.COLOR_BLACK);
	x = 7;
	for(y = 9; y <= 12; y +=1){
		PS.BeadColor(x, y, PS.COLOR_RED);
	}
	x = 8;
	for(y = 9; y <= 12; y +=1)
	PS.BeadColor(x, y, PS.COLOR_RED);
	PS.BeadColor(7, 13, PS.COLOR_BLACK);
	PS.BeadColor(8, 13, PS.COLOR_BLACK);
	x = 2;
	for(y = 10; y <= 22; y +=1)
	PS.BeadColor(x, y, PS.COLOR_BLACK);
	x = 13;
	for(y = 10; y <= 22; y +=1)
	PS.BeadColor(x, y, PS.COLOR_BLACK);
	PS.BeadColor(3, 23, PS.COLOR_BLACK);
	PS.BeadColor(12, 23, PS.COLOR_BLACK);
	PS.BeadColor(4, 24, PS.COLOR_BLACK);
	PS.BeadColor(11, 24, PS.COLOR_BLACK);
	y = 25;
	for(x = 5; x <= 10; x +=1)
	PS.BeadColor(x, y, PS.COLOR_BLACK);
	y = 14;
	for(x = 3; x <= 12; x +=1)
	PS.BeadColor(x, y, PS.COLOR_BLACK);
	
	//Draws the green up-arrow
	
	PS.BeadColor(18, 1, PS.COLOR_GREEN);
	PS.BeadColor(17, 2, PS.COLOR_GREEN);
	PS.BeadColor(18, 2, PS.COLOR_GREEN);
	PS.BeadColor(19, 2, PS.COLOR_GREEN);
	y = 3;
	for(x = 16; x <= 20; x +=1)
	PS.BeadColor(x, y, PS.COLOR_GREEN);
	x = 18;
	for(y = 4; y <= 8; y +=1)
	PS.BeadColor(x, y, PS.COLOR_GREEN);
	
	//Draws the black slash line
	
	PS.BeadColor(21, 7, PS.COLOR_BLACK);
	PS.BeadColor(22, 6, PS.COLOR_BLACK);
	PS.BeadColor(23, 5, PS.COLOR_BLACK);
	PS.BeadColor(24, 4, PS.COLOR_BLACK);
	PS.BeadColor(25, 3, PS.COLOR_BLACK);
	
	//Draws the orange down-arrow
	
	PS.BeadColor(28, 8, PS.COLOR_ORANGE);
	PS.BeadColor(27, 7, PS.COLOR_ORANGE);
	PS.BeadColor(28, 7, PS.COLOR_ORANGE);
	PS.BeadColor(29, 7, PS.COLOR_ORANGE);
	y = 6;
	for(x = 26; x <= 30; x +=1)
	PS.BeadColor(x, y, PS.COLOR_ORANGE);
	x = 28;
	for(y = 1; y <= 5; y +=1)
	PS.BeadColor(x, y, PS.COLOR_ORANGE);
	
	//Draws the counter-clockwise orange arrow
	
	y = 12;
	for(x = 20; x <= 22; x +=1)
	PS.BeadColor(x, y, PS.COLOR_ORANGE);
	PS.BeadColor(18, 13, PS.COLOR_ORANGE);
	PS.BeadColor(19, 13, PS.COLOR_ORANGE);
	PS.BeadColor(16, 13, PS.COLOR_ORANGE);
	PS.BeadColor(16, 14, PS.COLOR_ORANGE);
	PS.BeadColor(16, 15, PS.COLOR_ORANGE);
	PS.BeadColor(17, 14, PS.COLOR_ORANGE);
	PS.BeadColor(17, 15, PS.COLOR_ORANGE);
	PS.BeadColor(18, 15, PS.COLOR_ORANGE);
	
	//Draws the clockwise green arrow
	
	y = 12;
	for(x = 24; x <= 26; x +=1)
	PS.BeadColor(x, y, PS.COLOR_GREEN);
	PS.BeadColor(27, 13, PS.COLOR_GREEN);
	PS.BeadColor(28, 13, PS.COLOR_GREEN);
	PS.BeadColor(28, 15, PS.COLOR_GREEN);
	PS.BeadColor(29, 15, PS.COLOR_GREEN);
	PS.BeadColor(29, 14, PS.COLOR_GREEN);
	PS.BeadColor(30, 14, PS.COLOR_GREEN);
	PS.BeadColor(30, 15, PS.COLOR_GREEN);
	PS.BeadColor(30, 13, PS.COLOR_GREEN);
	
	//Draws the gear
	
	for(x = 21; x <= 22; x +=1)
	for(y = 16; y <= 19; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[1]);
	for(x = 23; x <= 24; x +=1)
	for(y = 18; y <= 21; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[1]);
	for(x = 25; x <= 26; x +=1)
	for(y = 16; y <= 21; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[1]);
	
	for(x = 21; x <= 22; x +=1)
	for(y = 24; y <= 29; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[2]);
	for(x = 23; x <= 24; x +=1)
	for(y = 24; y <= 27; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[2]);
	for(x = 25; x <= 26; x +=1)
	for(y = 26; y <= 29; y +=1)
	PS.BeadColor(x, y, COGS.block_colors[2]);
	
	for(y = 20; y <= 21; y +=1)
	for(x = 17; x <= 22; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[0]);
	for(y = 22; y <= 23; y +=1)
	for(x = 19; x <= 22; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[0]);
	for(y = 24; y <= 25; y +=1)
	for(x = 17; x <= 20; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[0]);
	
	for(y = 20; y <= 21; y +=1)
	for(x = 27; x <= 30; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[3]);
	for(y = 22; y <= 23; y +=1)
	for(x = 25; x <= 28; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[3]);
	for(y = 24; y <= 25; y +=1)
	for(x = 25; x <= 30; x +=1)
	PS.BeadColor(x, y, COGS.block_colors[3]);
	
	PS.Clock(5);
}

//Sets the game to the 'won' state
COGS.Win = function(){
	for(var i = 0; i < COGS.cog_list.length; i += 1){
		COGS.closest_block[i] = -1;
	}
	COGS.AI = true;
}

//Creates the final, AI-controlled level
COGS.CreateVictoryLevel = function(){
	COGS.InitVariables();
	
	//Spawn more beads because it looks cool
	COGS.block_spawn_rate = 90;
	COGS.block_spawn_cd = 24;
	COGS.DrawCog(19, 6, false, true, true, true);
	COGS.DrawCog(6, 11, true, true, false, true);
	COGS.DrawCog(24, 19, true, true, true, false);
	COGS.DrawCog(11, 25, true, false, true, true);
	PS.Clock(5);
}

//Creates a block in one of the starting locations at random
COGS.CreateBlock = function(){
	var block_instance = [];
	var instance_index = PS.Random(COGS.block_sources.length) - 1;
	while(COGS.block_source_counter[instance_index] > 0){
		instance_index = PS.Random(COGS.block_sources.length) - 1;
	}
	
	for(var i = 0; i < COGS.block_sources[instance_index].length; i += 1){
		block_instance[i] = COGS.block_sources[instance_index][i];
	}
	var color_index = PS.Random(4) - 1;
	block_instance[4] = COGS.block_colors[color_index];
	
	COGS.block_list.push(block_instance);
	PS.BeadColor(block_instance[0], block_instance[1], block_instance[4]);
	PS.BeadBorderWidth(block_instance[0], block_instance[1], 0);
}

//Moves the individual block at position index according to that block's movement rules
COGS.MoveBlock = function(index){
	PS.BeadColor(COGS.block_list[index][0], COGS.block_list[index][1], COGS.BG_colors[COGS.block_list[index][0]][COGS.block_list[index][1]]);
	PS.BeadBorderWidth(COGS.block_list[index][0], COGS.block_list[index][1], 1);
	
	COGS.block_list[index][0] += COGS.block_list[index][2];
	COGS.block_list[index][1] += COGS.block_list[index][3];
	
	if(PS.BeadData(COGS.block_list[index][0], COGS.block_list[index][1]) === 0){
		PS.BeadColor(COGS.block_list[index][0], COGS.block_list[index][1], COGS.block_list[index][4]);
		PS.BeadBorderWidth(COGS.block_list[index][0], COGS.block_list[index][1], 0);
	}
	else{
		if(PS.BeadColor(COGS.block_list[index][0], COGS.block_list[index][1]) === COGS.block_list[index][4]){
			PS.AudioPlay(COGS.block_sounds[PS.Random(COGS.block_sounds.length) - 1]);
			if(COGS.currentLevel !== 5){
				COGS.num_caught += 1;
				COGS.DrawProgressBar();
				if(COGS.num_caught >= COGS.level_end){
					PS.AudioPlay("perc_triangle");
					COGS.SwitchLevel(1);
					return;
				}
			}
		}
		else{
			if(COGS.currentLevel !== 5){
				PS.AudioPlay("fx_squawk");
				COGS.num_caught -= 3;
				if(COGS.num_caught < 0){
					COGS.num_caught = 0;
					if(COGS.currentLevel > 1){
						COGS.SwitchLevel(-1);
						return;
					}
				}
				COGS.DrawProgressBar();
			}
			else{
				//PS.Debug("It goofed.\n");
			}
		}
		COGS.removed_blocks.push(index);
	}
	
	if(COGS.AI){
		COGS.CheckBlockAI(index);
	}
}

//Checks if the block at the given index is the closest to any of the gears
//If it is the closest, that cog will start to rotate to catch it
COGS.CheckBlockAI = function(index){
	var blockcheck = COGS.block_list[index];
	for(var i = 0; i < COGS.cog_list.length; i += 1){
		//They share the same x
		if(blockcheck[0] === COGS.cog_list[i][0]){
			if(Math.abs(blockcheck[1] - COGS.cog_list[i][1]) <= 5 && Math.abs(blockcheck[1] - COGS.cog_list[i][1]) > Math.abs(blockcheck[1] + blockcheck[3] - COGS.cog_list[i][1])){
				if(COGS.closest_block[i] === -1){
					COGS.closest_block[i] = [index, Math.abs(blockcheck[1] - COGS.cog_list[i][1])];
				}
				else if(COGS.closest_block[i][1] > Math.abs(blockcheck[1] - COGS.cog_list[i][1])){
					COGS.closest_block[i] = [index, Math.abs(blockcheck[1] - COGS.cog_list[i][1])];
				}
			}
		}
		else if(blockcheck[1] === COGS.cog_list[i][1]){
			if(Math.abs(blockcheck[0] - COGS.cog_list[i][0]) <= 5 && Math.abs(blockcheck[0] - COGS.cog_list[i][0]) > Math.abs(blockcheck[0] + blockcheck[2] - COGS.cog_list[i][0])){
				if(COGS.closest_block[i] === -1){
					COGS.closest_block[i] = [index, Math.abs(blockcheck[0] - COGS.cog_list[i][0])];
				}
				else if(COGS.closest_block[i][1] > Math.abs(blockcheck[0] - COGS.cog_list[i][0])){
					COGS.closest_block[i] = [index, Math.abs(blockcheck[0] - COGS.cog_list[i][0])];
				}
			}
		}
	}
}

//Moves all the blocks on the screen, removes blocks that have been caught, and updates the 'closest block' list for the AI
COGS.MoveAllBlocks = function(){
	
	//Move each block
	for(var i = 0; i < COGS.block_list.length; i += 1){
		COGS.MoveBlock(i);
	}
	
	//Remove the blocks that have been caught
	var ai_refresh = false;
	for(var i = COGS.removed_blocks.length - 1; i >= 0; i -= 1){
		if(COGS.AI){
			for(var j = 0; j < COGS.closest_block.length; j += 1){
				if(COGS.closest_block[j][0] === COGS.removed_blocks[i]){
					COGS.closest_block[j] = -1;
					ai_refresh = true;
				}
			}
		}
		COGS.RemoveBlock(COGS.removed_blocks[i]);
	}
	
	//If the AI is on, and a block has been caught, search for the new 'closest block' for each cog
	if(ai_refresh){
		COGS.closest_block = [-1, -1, -1, -1];
		for(var i = 0; i < COGS.block_list.length; i += 1){
			COGS.CheckBlockAI(i);
		}
	}
	
	COGS.removed_blocks = [];
}

//Function strictly for the AI
//Moves the cog at COGS.cog_list[index] to catch the block that is closest to it
COGS.ShiftCog = function(index){
	var blockshift = COGS.block_list[COGS.closest_block[index][0]]
	var color = blockshift[4];
	
	if(color === PS.BeadColor(COGS.cog_list[index][0] - blockshift[2], COGS.cog_list[index][1] - blockshift[3])){
		return;
	}
	else if(color === PS.BeadColor(COGS.cog_list[index][0] + blockshift[3], COGS.cog_list[index][1] - blockshift[2])){
		COGS.RotateCounterClockwise(index);
	}
	else{
		COGS.RotateClockwise(index);
	}
}

//Removes a block from the game
//Called from MoveAllBlocks when a block runs into a cog
COGS.RemoveBlock = function(index){
	var start, end;
	start = COGS.block_list.slice(0, index);
	end = COGS.block_list.slice(index + 1, COGS.block_list.length);
	COGS.block_list = start.concat(end);
}

//Draws a cog at x, y, and creates the spawn locations for blocks it will catch
//top, bottom, left, right are booleans that define which sides this cog will catch blocks on
COGS.DrawCog = function (x, y, top, bottom, left, right) {
    var i, j;
    var topcolor = COGS.block_colors[0];
    var botcolor = COGS.block_colors[1];
    var leftcolor = COGS.block_colors[2];
    var rightcolor = COGS.block_colors[3];
    
    PS.BeadColor(x, y, COGS.bg_color);
    PS.BeadData(x, y, ["cog", COGS.cog_list.length]);
    PS.BeadBorderWidth(x, y, 0);
    
    for(j = y - 3; j <= y - 1; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x - 1) && (y - 3 !== j || i !== x)){
    			PS.BeadColor(i, j, topcolor);
    			PS.BeadData(i, j, ["cog", COGS.cog_list.length]);
    			PS.BeadBorderWidth(i, j, 0);
    		}
    		
    	}
    }
    
    for(j = y + 1; j <= y + 3; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y + 3 !== j || i !== x)){
    			PS.BeadColor(i, j, botcolor);
    			PS.BeadData(i, j, ["cog", COGS.cog_list.length]);
    			PS.BeadBorderWidth(i, j, 0);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x + 1; i <= x + 3; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y !== j || i !== x + 3)){
    			PS.BeadColor(i, j, rightcolor);
    			PS.BeadData(i, j, ["cog", COGS.cog_list.length]);
    			PS.BeadBorderWidth(i, j, 0);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x - 3; i <= x - 1; i += 1){
    		if((y + 1 !== j || i !== x - 1) && (y !== j || i !== x - 3)){
    			PS.BeadColor(i, j, leftcolor);
    			PS.BeadData(i, j, ["cog", COGS.cog_list.length]);
    			PS.BeadBorderWidth(i, j, 0);
    		}
    		
    	}
    }
    
    COGS.cog_list.push([x, y]);
    
    if(top){
    	COGS.block_sources.push([x, 0, 0, 1]);
    	COGS.block_source_counter.push(0);
    }
    if(bottom){
    	COGS.block_sources.push([x, COGS.gridY-1, 0, -1]);
    	COGS.block_source_counter.push(0);
    }
    if(left){
    	COGS.block_sources.push([0, y, 1, 0]);
    	COGS.block_source_counter.push(0);
    }
    if(right){
    	COGS.block_sources.push([COGS.gridX - 2, y, -1, 0]);
    	COGS.block_source_counter.push(0);
    }
}

//Rotates a cog counter-clockwise
COGS.RotateCounterClockwise = function(index){
	var topcolor, leftcolor, rightcolor, botcolor;
	var i, j;
	var x = COGS.cog_list[index][0];
	var y = COGS.cog_list[index][1];
	topcolor = PS.BeadColor(x, y - 1);
	botcolor = PS.BeadColor(x, y + 1);
	leftcolor = PS.BeadColor(x - 1, y);
	rightcolor = PS.BeadColor(x + 1, y);
	
	for(j = y - 3; j <= y - 1; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x - 1) && (y - 3 !== j || i !== x)){
    			PS.BeadColor(i, j, rightcolor);
    		}
    		
    	}
    }
    
    for(j = y + 1; j <= y + 3; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y + 3 !== j || i !== x)){
    			PS.BeadColor(i, j, leftcolor);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x + 1; i <= x + 3; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y !== j || i !== x + 3)){
    			PS.BeadColor(i, j, botcolor);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x - 3; i <= x - 1; i += 1){
    		if((y + 1 !== j || i !== x - 1) && (y !== j || i !== x - 3)){
    			PS.BeadColor(i, j, topcolor);
    		}
    		
    	}
    }
}

//Rotates a cog clockwise
COGS.RotateClockwise = function(index){
	var topcolor, leftcolor, rightcolor, botcolor;
	var x = COGS.cog_list[index][0];
	var y = COGS.cog_list[index][1];
	topcolor = PS.BeadColor(x, y - 1);
	botcolor = PS.BeadColor(x, y + 1);
	leftcolor = PS.BeadColor(x - 1, y);
	rightcolor = PS.BeadColor(x + 1, y);
	
	for(j = y - 3; j <= y - 1; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x - 1) && (y - 3 !== j || i !== x)){
    			PS.BeadColor(i, j, leftcolor);
    		}
    		
    	}
    }
    
    for(j = y + 1; j <= y + 3; j += 1){
    	for(i = x - 1; i <= x + 1; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y + 3 !== j || i !== x)){
    			PS.BeadColor(i, j, rightcolor);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x + 1; i <= x + 3; i += 1){
    		if((y - 1 !== j || i !== x + 1) && (y !== j || i !== x + 3)){
    			PS.BeadColor(i, j, topcolor);
    		}
    		
    	}
    }
    
    for(j = y - 1; j <= y + 1; j += 1){
    	for(i = x - 3; i <= x - 1; i += 1){
    		if((y + 1 !== j || i !== x - 1) && (y !== j || i !== x - 3)){
    			PS.BeadColor(i, j, botcolor);
    		}
    		
    	}
    }
}

//Draws the progress bar
//On the first level, half as many blocks are required to pass
COGS.DrawProgressBar = function(){
	if(COGS.currentLevel !== 1){
		for(var i = COGS.gridY - 1; i >= 0; i -= 1){
			if((i+1) * 2 <= COGS.num_caught){
				PS.BeadColor(31, COGS.gridY - 1 - i, COGS.progress_full);
			}
			else if(COGS.num_caught % 2 === 1 && COGS.num_caught < (i+1)*2 && COGS.num_caught > i * 2){
				PS.BeadColor(31, COGS.gridY - 1 -  i, COGS.progress_half);
			}
			else{
				PS.BeadColor(31, COGS.gridY - 1 -  i, COGS.progress_empty);
			}
			PS.BeadBorderWidth(31, COGS.gridY - 1 -  i, 0);
		}
	}
	else{
		for(var i = COGS.gridY - 1; i >= 0; i -= 1){
			if((i+1) <= COGS.num_caught){
				PS.BeadColor(31, COGS.gridY - 1 - i, COGS.progress_full);
			}
			else{
				PS.BeadColor(31, COGS.gridY - 1 -  i, COGS.progress_empty);
			}
			PS.BeadBorderWidth(31, COGS.gridY - 1 -  i, 0);
		}
	}
}

//Creates the configuration for the first level and starts it
COGS.CreateLevelOne = function(){
	COGS.InitVariables();
	COGS.DrawCog(15, 15, true, true, true, true);
	PS.Clock(5);
}

//Creates the configuration for the second level and starts it
COGS.CreateLevelTwo = function(){
	COGS.InitVariables();
	COGS.DrawCog(6, 6, false, true, false, true);
    COGS.DrawCog(24, 24, true, false, true, false);
	PS.Clock(5);
}

//Creates the configuration for the third level and starts it
COGS.CreateLevelThree = function(){
	COGS.InitVariables();
	COGS.DrawCog(6, 6, false, true, false, true);
	COGS.DrawCog(15, 15, true, true, true, true);
	PS.Clock(5);
}

//Creates the configuration for the fourth level and starts it
COGS.CreateLevelFour = function(){
	COGS.InitVariables();
	COGS.DrawCog(6, 6, false, true, false, true);
    COGS.DrawCog(15, 15, true, true, true, true);
    COGS.DrawCog(24, 24, true, false, true, false);
	PS.Clock(5);
}

//Changes the current level, either forward or back depending on the value of level_adjust
COGS.SwitchLevel = function(level_adjust){
	PS.BeadFlash(PS.ALL, PS.ALL, true);
	COGS.currentLevel += level_adjust;
	if(COGS.currentLevel === 1){
		COGS.CreateLevelOne();
	}
	else if(COGS.currentLevel === 2){
		COGS.CreateLevelTwo();
	}
	else if(COGS.currentLevel === 3){
		COGS.CreateLevelThree();
	}
	else if(COGS.currentLevel === 4){
		COGS.CreateLevelFour();
	}
	else if(COGS.currentLevel === 5){
		COGS.CreateVictoryLevel();
		COGS.Win();
	}
	COGS.num_caught = COGS.level_end/2;
	if(COGS.currentLevel !== 5){
		COGS.DrawProgressBar();
	}
	
	if(COGS.AI){
		for(var i = 0; i < COGS.cog_list.length; i += 1){
			COGS.closest_block[i] = -1;
		}
	}
	PS.BeadFlash(PS.ALL, PS.ALL, false);
}

//Initializes the game variables, resizes the grid, and starts the game
COGS.StartGame = function(){
	PS.GridSize(COGS.gridX, COGS.gridY);
	PS.BeadFlash(PS.ALL, PS.ALL, true);
	PS.BeadBorderWidth(PS.ALL, PS.ALL, 1);
	PS.BeadBorderColor(PS.ALL, PS.ALL, COGS.bg_color);
    PS.GridBGColor(COGS.bg_color);
	COGS.currentLevel = 1;
	COGS.CreateLevelOne();
	COGS.DrawProgressBar();
	PS.BeadFlash(PS.ALL, PS.ALL, false);
	PS.StatusText("Point at the cog");
}

//Resets the level variables
//Called at the start of each level
COGS.InitVariables = function(){
	COGS.cog_list = [];
	
	COGS.mouseData = [];
	COGS.scrollcd = 2;
	COGS.scroll_counter = 0;
	
	COGS.block_list = [];
	COGS.block_sources = [];
	
	COGS.block_source_counter = [];
	COGS.source_cd = 60;
	
	COGS.removed_blocks = [];
	COGS.block_cd = 3;
	COGS.block_counter = COGS.block_cd;
	COGS.block_spawn_rate = 60;
	COGS.num_caught = 0;
	
	
	COGS.block_spawn_cd = 12;
	COGS.block_spawn_counter = COGS.block_spawn_cd + 15;
	
	PS.BeadBorderWidth(PS.ALL, PS.ALL, 1);
	COGS.DrawBG();
	PS.BeadData(PS.ALL, PS.ALL, 0);
	
	if(COGS.currentLevel !== 1){
		COGS.level_end = COGS.gridY * 2;
		COGS.block_spawn_rate = 50;
	}
	else{
		COGS.level_end = COGS.gridY;
		COGS.block_spawn_rate = 50;
	}
	
	COGS.max_blocks = COGS.max_blocks_level[COGS.currentLevel - 1];
	COGS.closest_block = [];
}

// PS.Init ()
// Initializes the game
// This function normally includes a call to PS.GridSize (x, y)
// where x and y are the desired dimensions of the grid

PS.Init = function () {
    "use strict";

    // change to the dimensions you want
    COGS.FullInit();
    PS.GridSize(COGS.gridX, COGS.gridY + 1);
    PS.BeadFlash(PS.ALL, PS.ALL, false);
    PS.BeadBorderWidth(PS.ALL, PS.ALL, 0);  				
    PS.GridBGColor(COGS.bg_color);
    PS.StatusText("Just Cogs");
	
	COGS.DrawTitleScreen();
	
};

// PS.Click (x, y, data)
// This function is called whenever a bead is clicked
// It doesn't have to do anything
// x = the x-position of the bead on the grid
// y = the y-position of the bead on the grid
// data = the data value associated with this bead, 0 if none has been set
//Starts the game if the title screen is active
PS.Click = function (x, y, data)
{
	"use strict";
	if( COGS.title )
	{
		COGS.title = false;
		COGS.StartGame();
	}
};

// PS.Release (x, y, data)
// This function is called whenever a mouse button is released over a bead
// It doesn't have to do anything
// x = the x-position of the bead on the grid
// y = the y-position of the bead on the grid
// data = the data value associated with this bead, 0 if none has been set

PS.Release = function (x, y, data)
{
	"use strict";

	// Put code here for when the mouse button is released over a bead	
};

// PS.Enter (x, y, button, data)
// This function is called whenever the mouse moves over a bead
// It doesn't have to do anything
// x = the x-position of the bead on the grid
// y = the y-position of the bead on the grid
// data = the data value associated with this bead, 0 if none has been set
//Keeps track of which cog the mouse is currently over

COGS.seenOn = false;
COGS.seenOff = false;

PS.Enter = function (x, y, data)
{
	"use strict";
	COGS.mouseData = data;
	if ( !COGS.title )
	{
		if ( data ) // pointing at a cog?
		{		
			if ( !COGS.seenOn ) // show only once
			{
				COGS.seenOn = true;
				COGS.seenOff = false;
				PS.StatusText("Use mouse wheel to rotate cog");
			}
		}
		else
		{
			if ( !COGS.seenOff )
			{
				COGS.seenOff = true;
				COGS.seenOn = false;
				PS.StatusText("Point at a cog");
			}
		}
	}
};

// PS.Leave (x, y, data)
// This function is called whenever the mouse moves away from a bead
// It doesn't have to do anything
// x = the x-position of the bead on the grid
// y = the y-position of the bead on the grid
// data = the data value associated with this bead, 0 if none has been set

PS.Leave = function (x, y, data)
{
	"use strict";

	// Put code here for when the mouse leaves a bead	
};

// PS.Key (key, shift, ctrl)
// This function is called whenever a key on the keyboard is pressed
// It doesn't have to do anything
// key = the ASCII code of the pressed key, or one of the following constants:
// Arrow keys = PS.ARROW_UP, PS.ARROW_DOWN, PS.ARROW_LEFT, PS.ARROW_RIGHT
// Function keys = PS.F1 through PS.F1
// shift = true if shift key is held down, false otherwise
// ctrl = true if control key is held down, false otherwise

PS.KeyDown = function (key, shift, ctrl)
{
	"use strict";

	// Put code here for when a key is pressed	
};

// PS.KeyUp (key, shift, ctrl)
// This function is called whenever a key on the keyboard is released
// It doesn't have to do anything
// key = the ASCII code of the pressed key, or one of the following constants:
// Arrow keys = PS.ARROW_UP, PS.ARROW_DOWN, PS.ARROW_LEFT, PS.ARROW_RIGHT
// Function keys = PS.F1 through PS.F12
// shift = true if shift key is held down, false otherwise
// ctrl = true if control key is held down, false otherwise
//If the player presses 'A', the AI is toggled on/off
//If the player presses F5, the game resets
PS.KeyUp = function (key, shift, ctrl)
{
	"use strict";
	if(key === 65 && COGS.currentLevel !== 5){
		for(var i = 0; i < COGS.cog_list.length; i += 1){
			COGS.closest_block[i] = -1;
		}
		COGS.AI = !COGS.AI;
	}
	if(key === PS.F5){
		PS.Clock(0);
		PS.Init();
	}
	// Put code here for when a key is released	
};

// PS.Wheel (dir)
// This function is called whenever the mouse wheel moves forward or backward
// It doesn't have to do anything
// dir = 1 if mouse wheel moves forward, -1 if backward
//Rotates a cog clockwise or counter-clockwise if the mouse is hovering over it
PS.Wheel = function (dir)
{
	"use strict";
	if (COGS.mouseData !== 0 && !COGS.AI)
	{
		if (COGS.mouseData[0] === "cog" && COGS.scroll_counter === 0)
		{
			if (dir === 1)
			{
				COGS.RotateClockwise(COGS.mouseData[1]);
			}
			else
			{
				COGS.RotateCounterClockwise(COGS.mouseData[1]);
			}
			COGS.scroll_counter = COGS.scrollcd;
		}
	}
};

// PS.Tick ()
// This function is called on every clock tick
// if a timer has been activated with a call to PS.Timer()
// It doesn't have to do anything

PS.Tick = function () {
    "use strict";
    if(COGS.title){
    	if(COGS.flash_counter <= 0){
    		var x, y;
    		for(x = 7; x <= 8; x += 1){
				for(y = 9; y <= 12; y +=1){
					PS.BeadFlash(x, y, true);
					PS.BeadColor(x, y, PS.COLOR_RED);
				}
			}
			COGS.flash_counter = COGS.flash_cd;
    	}
    	else{
    		COGS.flash_counter -= 1;
    	}
    	
    }
    else{
	    if (COGS.scroll_counter > 0) {
	        COGS.scroll_counter -= 1;
	    }
	
	    if (COGS.block_counter > 0) {
	        COGS.block_counter -= 1;
	    }
	    else {
	        COGS.MoveAllBlocks();
	        COGS.block_counter = COGS.block_cd;
	    }
	
	    for (var i = 0; i < COGS.block_source_counter.length; i += 1) {
	        if (COGS.block_source_counter[i] > 0) {
	            COGS.block_source_counter[i] -= 1;
	        }
	    }
	
	    if (COGS.block_spawn_counter === 0) {
	    	if(COGS.max_blocks > COGS.block_list.length){
		        if (PS.Random(100) <= COGS.block_spawn_rate) {
		            COGS.CreateBlock();
		        }
	        }
	        COGS.block_spawn_counter = COGS.block_spawn_cd;
	    }
	    else {
	        COGS.block_spawn_counter -= 1;
	    }
	    
	    if(COGS.AI){
	    	if(COGS.ai_counter <= 0){
	    		for(var i = 0; i < COGS.closest_block.length; i += 1){
					if(COGS.closest_block[i] !== -1){
						COGS.ShiftCog(i);
					}
				}
	    		COGS.ai_counter = COGS.ai_cd;
	    	}
	    	else{
	    		COGS.ai_counter -= 1;
	    	}
	    	
	    }
    }
};
